// PSN Header Info

#define WORD	unsigned short
#define BYTE	unsigned char

#pragma pack(1)		// data must be packed on 1 byte boundaries 

/* Time and date structure */
typedef struct  {
	WORD 	year;
	char	month;
	char	day;
	char	hour;
	char	minute;
	char	second;
	char	notUsed;
	long	nanoseconds;
} DateTime;
	
/* Holds event information */
typedef struct  {
	DateTime eventTime;
	double 	latitude;
	double 	longitude;
	double 	depth;
	short	ms, mb, mw, ml, md, mOther;
	char	otherType[4];
	char	typeCode;
	char 	qualityChar;
	WORD	flags;
	char	agency[6];
} EventInfo;

/* Holds phase pick information */
typedef struct  {
	DateTime pickTime;
	char 	phaseName[8];
	WORD	flags;
	short	yLocation;
	char	fileName[16];
	short	tableDepth;
} PickInfo;

/* Variable length header header */
typedef struct  {
	BYTE 	checkNumber;
	BYTE 	id;
	long 	length;
} VarHeader;
	
/* flags for flags field below */
#define NO_CRC		0x00000001
#define NO_MINMAX	0x00000002
	
/* See http://www.seismicnet.com/psnformat4.html for field information */
typedef struct  {
	char 	headerID[8];
	long 	varHdrLength;
	DateTime startTime;
	double 	startTimeOffset;
	double 	spsRate;
	long 	sampleCount;
	long	flags;
	char	timeRefType[3];
	char	timeRefStatus;
	BYTE	sampleType;
	BYTE	sampleCompression;
	double	compIncident;
	double	compAzimuth;
	char	compOrientation;
	BYTE	sensorType;
	double	latitude;
	double	longitude;
	double	elevation;
	char	name[6];
	char	compName[4];
	char 	network[6];
	double	sensitivity;
	double	magCorr;
	short	atodBits;
	double	minimum;
	double	maximum;
	double 	mean;
} PSNType4;

#pragma pack()
